% As used originally in Beagle:
tff(hack_1, axiom, ~(? [X: $rat] : (2/1 = '#nlpp'(X, X)))).

tff(quo_1, axiom, ![X: $rat, Y: $rat]: ( Y != 0/1 => X = $product(Y, $quotient(X, Y))) ).
% quo_1 provable from nonzero_eq_divide_eq

% Quotient definition
%% lemma nonzero_eq_divide_eq [field_simps]: "c ≠ 0 ⟹ a = b / c ⟷ a * c = b"
% nonzero_eq_divide_eq unsound without guard Y!=0
% note: nonzero_eq_divide_eq eventually causes a bug where rat is initialised with x/0?
tff(nonzero_eq_divide_eq, axiom, ![X: $rat, Y: $rat, Z: $rat]: ( Y != 0/1 => ( Z = $quotient(X, Y) <=> X = $product(Y, Z)) ) ).

%% lemma divide_divide_eq_left [simp]: "(a / b) / c = a / (b * c)"
tff(divide_divide_eq_left, axiom, ![X: $rat, Y: $rat, Z: $rat]: $quotient($quotient(X,Y),Z) = $quotient(X, $product(Y, Z))).

%% lemma divide_divide_eq_right [simp]: "a / (b / c) = (a * c) / b"
tff(divide_divide_eq_right, axiom, ![X: $rat, Y: $rat, Z: $rat]: $quotient(X, $quotient(Y,Z)) = $quotient($product(X, Y), Z)).

% Definition
tff(mult_def_1, axiom, ![N: $rat]: '#nlpp'(0/1, N) = 0/1).
tff(mult_def_2, axiom, ![M: $rat, N: $rat] : $product($sum(1/1, M), N) = $sum(N, $product(M, N)) ).

%% % Basic axioms
tff(mult_comm, axiom, ![A: $rat, B: $rat]: $product(A,B) = $product(B,A)).
tff(mult_dist, axiom, ![A: $rat, B: $rat, C: $rat]: $product(A, $sum(B,C)) = $sum($product(A, B), $product(A, C))).
% Kills performance
%% tff(mult_assoc, axiom, ![A: $rat, B: $rat, C: $rat]: $product($product(A,B),C) = $product(A, $product(B,C))).

% Lemmas for simplification
%lemma minus_mult_left: "- (a * b) = - a * b"
tff(minus_mult_left, axiom, ![A: $rat, B: $rat]: $uminus($product(A, B)) = $product($uminus(A), B)).
% conjecture not provable

%% lemma mult_cancel_right1 [simp]: "c = b * c ⟷ c = 0 ∨ b = 1"
tff(mult_cancel_right1, axiom, ![C: $rat, B: $rat]: ($product(C, B) = C <=> (C = 0/1 | B = 1/1))).
% not provable
% provable from comm, mult_eq_0 in 8s

%% %% lemma mult_pos_pos[simp]: "0 < a ⟹ 0 < b ⟹ 0 < a * b"
tff(mult_nonneg_nonneg, axiom, ![A: $rat, B: $rat]: (($less(0/1, A) & $less(0/1,B)) => $less(0/1, $product(A,B)))).
%% % not provable

%% lemma times_divide_eq_right [simp]: "a * (b / c) = (a * b) / c"
tff(times_divide_eq_right, axiom, ![A: $rat, B: $rat, C: $rat]: ($product(A, $quotient(B, C)) = $quotient($product(A, B), C)) ).
%% % not provable

%% lemma divide_minus_left [simp]: "(-a) / b = - (a / b)"
tff(divide_minus_left, axiom, ![A: $rat, B: $rat]: $quotient($uminus(A), B) = $uminus($quotient(A, B))).
% not provable

%% lemma divide_minus_right [simp]: "a / - b = - (a / b)"
tff(divide_minus_right, axiom, ![A: $rat, B: $rat]: $quotient(A, $uminus(B)) = $uminus($quotient(A, B))).

%% lemma add_divide_eq_iff [field_simps]: "z ≠ 0 ⟹ x + y / z = (x * z + y) / z"
tff(add_divide_eq_iff, axiom, ![A: $rat, B: $rat, C: $rat]: (C != 0/1 => $sum(A, $quotient(B, C)) = $quotient($sum($product(A, C), B), C)) ).
% not provable

tff(simpler_add_divide, axiom, ![A: $rat, B: $rat, C: $rat]: ( C != 0/1 => ($sum($quotient(A, C), $quotient(B, C)) = $quotient($sum(A, B), C)) )).
% doesnt help to prove add_divide_eq_iff, neither is it provable from that

%% lemma nonzero_mult_divide_mult_cancel_left [simp]: "(c * a) / (c * b) = a / b"
tff(nonzero_mult_divide_mult_cancel_left, axiom, ![A: $rat, B: $rat, C: $rat]: ( B != 0/1 => $quotient($product(C, A), $product(C, B)) = $quotient(A, B))).

%% lemma add_divide_eq_if_simps [divide_simps]:
%%     "a + b / z = (if z = 0 then a else (a * z + b) / z)"
%%     "a / z + b = (if z = 0 then b else (a + b * z) / z)"
%%     "- (a / z) + b = (if z = 0 then b else (-a + b * z) / z)"
%%     "a - b / z = (if z = 0 then a else (a * z - b) / z)"
%%     "a / z - b = (if z = 0 then -b else (a - b * z) / z)"
%%     "- (a / z) - b = (if z = 0 then -b else (- a - b * z) / z)"
%%   by (simp_all add: add_divide_eq_iff divide_add_eq_iff diff_divide_eq_iff divide_diff_eq_iff
%%       minus_divide_diff_eq_iff)

%% lemma pos_le_divide_eq [field_simps]:
%%   assumes "0 < c"
%%   shows "a ≤ b / c ⟷ a * c ≤ b"

%% lemma pos_less_divide_eq [field_simps]:
%%   assumes "0 < c"
%%   shows "a < b / c ⟷ a * c < b"
tff(pos_less_divide_eq, axiom, ![A: $rat, B: $rat, C: $rat]: ($less(0/1, C) => ($less(A, $quotient(B, C)) <=> $less($product(A, C), B)))).

%% lemma neg_less_divide_eq [field_simps]:
%%   assumes "c < 0"
%%   shows "a < b / c ⟷ b < a * c"

%% lemma pos_divide_le_eq [field_simps]:
%%   assumes "0 < c"
%%   shows "b / c ≤ a ⟷ b ≤ a * c"
%% tff(pos_less_divide_le_eq, conjecture, ![A: $rat, B: $rat, C: $rat]: ($less(0/1, C) => ($lesseq($quotient(B, C), A) <=> $lesseq(B, $product(A, C))))).
% provable from pos_less_divide_eq in 10s

%% lemma pos_le_minus_divide_eq [field_simps]: "0 < c ⟹ a ≤ - (b / c) ⟷ a * c ≤ - b"
%%   unfolding minus_divide_left by (rule pos_le_divide_eq)

%% lemma neg_le_minus_divide_eq [field_simps]: "c < 0 ⟹ a ≤ - (b / c) ⟷ - b ≤ a * c"
%%   unfolding minus_divide_left by (rule neg_le_divide_eq)

%% lemma pos_less_minus_divide_eq [field_simps]: "0 < c ⟹ a < - (b / c) ⟷ a * c < - b"
%%   unfolding minus_divide_left by (rule pos_less_divide_eq)

%% lemma neg_less_minus_divide_eq [field_simps]: "c < 0 ⟹ a < - (b / c) ⟷ - b < a * c"
%%   unfolding minus_divide_left by (rule neg_less_divide_eq)

%% lemma pos_minus_divide_less_eq [field_simps]: "0 < c ⟹ - (b / c) < a ⟷ - b < a * c"
%%   unfolding minus_divide_left by (rule pos_divide_less_eq)

%% lemma neg_minus_divide_less_eq [field_simps]: "c < 0 ⟹ - (b / c) < a ⟷ a * c < - b"
%%   unfolding minus_divide_left by (rule neg_divide_less_eq)

%% lemma pos_minus_divide_le_eq [field_simps]: "0 < c ⟹ - (b / c) ≤ a ⟷ - b ≤ a * c"
%%   unfolding minus_divide_left by (rule pos_divide_le_eq)

%% lemma neg_minus_divide_le_eq [field_simps]: "c < 0 ⟹ - (b / c) ≤ a ⟷ a * c ≤ - b"
%%   unfolding minus_divide_left by (rule neg_divide_le_eq)
% skipped

%% lemma le_divide_eq_1_pos [simp]:
%%   "0 < a ⟹ (1 ≤ b/a) = (a ≤ b)"
%% by (auto simp add: le_divide_eq
tff(le_divide_eq_1_pos, axiom, ![A: $rat, B: $rat]: ($less(0/1, A) => ($lesseq(1/1, $quotient(B, A)) <=> $lesseq(A, B))) ).


%% lemma less_divide_eq_1_pos [simp]:
%%   "0 < a ⟹ (1 < b/a) = (a < b)"
%% by (auto simp add: less_divide_eq)
tff(less_divide_eq_1_pos, axiom, ![A: $rat, B: $rat]: ($less(0/1, A) => ($less(1/1, $quotient(B, A)) <=> $less(A, B))) ).

% Provable:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Now a SimpRule
%% tff(quo_4, conjecture, ![X: $rat]: $quotient(X, 1/1) = X).
%% tff(quo_3, conjecture, ![X: $rat]: ( X != 0/1 => $quotient(0/1, X) = 0/1) ).

% tff(quo_ident, conjecture, ![X: $rat]: ( X != 0/1 => $quotient(X, X) = 1/1 ) ).

%% lemma nonzero_neg_divide_eq_eq [field_simps]: "b ≠ 0 ⟹ - (a / b) = c ⟷ - a = c * b"
%% tff(nonzero_neg_divide_eq_eq, conjecture, ![A: $rat, B: $rat, C: $rat]: (B != 0/1 => ($uminus($quotient(A, B)) = C <=> $uminus(A) = $product(C, B))) ).
% provable in 10s

%% lemma nonzero_mult_divide_mult_cancel_right [simp]: "c ≠ 0 ⟹ (a * c) / (b * c) = a / b"
%% tff(nonzero_mult_divide_mult_cancel_right, conjecture, ![A: $rat, B: $rat, C: $rat]: ( C != 0/1 => $quotient($product(A, C), $product(B, C)) = $quotient(A, B))).
% provable in 12s

%% lemma nonzero_mult_divide_mult_cancel_left2 [simp]:
%%   "c ≠ 0 ⟹ (c * a) / (b * c) = a / b"

%% lemma nonzero_mult_divide_mult_cancel_right2 [simp]:
%%   "c ≠ 0 ⟹ (a * c) / (c * b) = a / b"

%% lemma nonzero_divide_mult_cancel_right [simp]: "b ≠ 0 ⟹ b / (a * b) = 1 / a
%% tff(nonzero_mult_divide_mult_cancel_right, conjecture, ![A: $rat, B: $rat]: ( B != 0/1 =>  $quotient(B, $product(A, B)) = $quotient(1/1, B))).
% provable from nonzero_mult_divide_mult_cancel_left

%% lemma nonzero_divide_mult_cancel_left [simp]: "a ≠ 0 ⟹ a / (a * b) = 1 / b"

%% lemma divide_cancel_right [simp]: "a / c = b / c ⟷ c = 0 ∨ a = b"
%% tff(divide_cancel_right, conjecture, ![A: $rat, B: $rat, C: $rat]: ($quotient(A,C) = $quotient(B,C) <=> (C = 0/1 | A = B))).
%% tff(divide_cancel_right, conjecture, ![A: $rat, B: $rat, C: $rat]: ( C != 0/1 => ($quotient(A,C) = $quotient(B,C) <=> A = B))).
% provable

%% lemma divide_eq_1_iff [simp]: "a / b = 1 ⟷ b ≠ 0 ∧ a = b"
%% tff(divide_eq_1_iff, conjecture, ![A: $rat, B: $rat]: ($quotient(A,B) = 1/1 <=> (B != 0/1 & A = B))).
% provable

%% lemma divide_pos_pos[simp]: "0 < x ==> 0 < y ==> 0 < x / y"
%% tff(divide_pos_pos, conjecture, ![A: $rat, B: $rat]: ( ($less(0/1, A) & $less(0/1, B)) => $less(0/1, $quotient(A, B)) )).
% provable

%% lemma less_divide_eq_1_neg [simp]:
%%   "a < 0 ⟹ (1 < b/a) = (b < a)"
%% by (auto simp add: less_divide_eq)

%% lemma divide_less_eq_1_pos [simp]:
%%   "0 < a ⟹ (b/a < 1) = (b < a)"
%% by (auto simp add: divide_less_eq)

%% lemma divide_less_eq_1_neg [simp]:
%%   "a < 0 ⟹ b/a < 1 ⟷ a < b"
%% by (auto simp add: divide_less_eq)

%% lemma eq_divide_eq_1 [simp]:
%%   "(1 = b/a) = ((a ≠ 0 & a = b))"
%% by (auto simp add: eq_divide_eq)
%% tff(a, conjecture,![A: $rat, B: $rat]: (1/1 = $quotient(B,A) <=> (A != 0/1 & A = B))).

%% lemma divide_eq_eq_1 [simp]:
%%   "(b/a = 1) = ((a ≠ 0 & a = b))"
%% by (auto simp add: divide_eq_eq)

%% lemma divide_nonneg_nonneg [simp]:
%%   "0 ≤ x ⟹ 0 ≤ y ⟹ 0 ≤ x / y"
%%   by (auto simp add: divide_simps)

%% lemma le_divide_eq_1_neg [simp]:
%%   "a < 0 ⟹ (1 ≤ b/a) = (b ≤ a)"
%% by (auto simp add: le_divide_eq)
%% tff(le_divide_eq_1_neg, conjecture, ![A: $rat, B: $rat]: ($less(A, 0/1) => ($lesseq(1/1, $quotient(B, A)) <=> $lesseq(B, A))) ).
% provable from positive form of this
%% lemma divide_le_eq_1_pos [simp]:
%%   "0 < a ⟹ (b/a ≤ 1) = (b ≤ a)"
%% by (auto simp add: divide_le_eq)

%% lemma divide_le_eq_1_neg [simp]:
%%   "a < 0 ⟹ (b/a ≤ 1) = (a ≤ b)"
%% by (auto simp add: divide_le_eq)
